	program build2
C--------------------------------------------------------
	character	srcname*100
	character	wavname*100

	include	"common.inc"

	integer		fdout
	integer		ligne
	integer		f1, f2, t1, t2, e1, e2, d1, d2
	integer		szsmpl
	integer		silence
	integer*2	buffs1(30000) ,	buffs2(30000)
	integer*2	buffe1(30000) ,	buffe2(30000)
	integer*2	tamp1(30000) ,	tamp2(30000)

	include 		'sound77.inc'
C--------------------------------------------------------
C	Checking command-line parameters
	if (IARGC() .ne. 2) then
	    print *, '---> parameters are: srcname wavname'
	    stop 'bad parameters'
	endif
	call GETARG(1, srcname)
	call GETARG(2, wavname)

C---	Open and start read the source file
	open (unit=20, file=srcname, err=9999, status='old')
	read (20, 11) samplerate
	read (20, 11) bpm
	read (20, 11) level
11	format(i5)
	write(6,21) samplerate, bpm
21	format('sample rate ', i5, ', BPM ', i3)

	szsmpl = 19168
	silence = 1200

C---	Create the output file
	fdout = sndfopen(wavname, 'O', samplerate, 2)
	if (fdout .lt. 0) then
	    stop
	end if
	call silence2(fdout, 3000)

C--------------------------------------------------------
	call menv02(buffe1, szsmpl, level, real(0.1))
	call menv02(buffe2, szsmpl, level, real(0.1))
	

C------------- start of main loop -----------------------
	ligne = 0
100	continue

	read(20, 31) f1, t1, e1, d1, f2, t2, e2, d2
31	format(8i3)

	if (f1 .eq. -1) goto 9999

	ligne = ligne + 1
	write(6, 32) ligne, f1, t1, f2, t2
32	format(i6, 2(' :   ', i6, i6))

	call buildnote(buffs1, szsmpl, f1, t1)
	call oper01(buffs1, buffe1, tamp1, szsmpl)

	call buildnote(buffs2, szsmpl, f2, t2)
	call oper01(buffs2, buffe2, tamp2, szsmpl)

	call buff2wav(fdout, tamp1, tamp2, szsmpl)
	call silence2(fdout, silence)

	goto 100

9999	continue
	write(6,41)
41	format('finbo')

C	Close the outputfile
	call silence2(fdout, 3000)
	call sndfclose(fdout)

	end
C--------------------------------------------------------
	subroutine buildnote(buff, sz, note, son)
	integer		sz
	integer*2	buff(sz)
	integer		note, son

	include		"common.inc"

	double precision freq, midi2hz

	freq = midi2hz(note)
	if (son .eq. 1) then
	    call wavf01(buff, sz, freq, samplerate)
	elseif (son .eq. 2) then
	    call wavf02(buff, sz, freq, samplerate)
	elseif (son .eq. 3) then
	    call wavf03(buff, sz, freq, samplerate)
	elseif (son .eq. 4) then
	    call wavf04(buff, sz, freq, samplerate)
	else
	    call wavf00(buff, sz)
	endif

	end
C--------------------------------------------------------
