#!/bin/sh

OUTFILE=toto.txt
date > $OUTFILE
echo >> $OUTFILE

make toto
./toto > toto.dat
head -5 toto.dat >> $OUTFILE
echo >> $OUTFILE

gnuplot >> $OUTFILE << EOC
set term gif
set output 'toto.gif'
plot 'toto.dat' using 1:4
EOC

make plotenv
./plotenv 0.8 
gnuplot >> $OUTFILE << EOC
set term gif
set output 'env.gif'
plot 'env.dat' using 1:2
EOC

