C--------------------------------------------------------
C	s77echo - my first sound filter :)
C	http://tontonth.free.fr/sound77.html
C--------------------------------------------------------
	program s77echo

	integer		tbuff
	parameter	(tbuff=200000)

	integer*2	sleft, sright
	integer*2	dleft, dright
	integer*2	tbleft(tbuff),tbright(tbuff)
	integer		idx, foo, echo
	integer		fnin, fnout, smplrate, nbchann
	character*20	chaine
	character*100	infname, outfname

C----	prototypes
	integer		sndfopen,sndfget2,sndfget

C----	Initialisations
	do 10 foo=1,tbuff
	    tbleft(foo) = 0
	    tbright(foo) = 0
10	continue

	if (IARGC() .ne. 3) then
	    print *,'Erreur arguments: infile.wav nnnnn outfile.wav'
	    call exit(1)
	end if

C----	get and decode parameters
	call getarg(1, infname)
	call getarg(2, chaine)
	read(chaine,*) echo
	call getarg(3, outfname)

C----	open input file
	fnin = sndfopen(infname, 'I', smplrate, nbchann)
	if (fnin .lt. 0) then
	    write(6, 50) fnin
	    call exit(2)
	end if
50	format('Err open infile', i5)

C----	create output wavfile
	fnout = sndfopen(outfname, 'O', smplrate, nbchann)
	if (fnout .lt. 0) then
	    write(6, 51) fnout
	    call exit(2)
	end if
51	format('Err open outfile', i5)

	write(6,52) smplrate, nbchann
52	format('s77echo ', 2i10)

	if (nbchann .eq. 1) goto 200

C----	stereophonic echo
	idx = 1
	do
	    foo = sndfget2(fnin, sleft, sright)
	    if (foo .ne. 2) goto 201
	    dleft = ((3 * sleft) + tbleft(idx)) / 4
	    dright = ((3 * sright) + tbright(idx)) / 4
	    tbleft(idx) = sleft
	    tbright(idx) = sright
	    idx = idx + 1
	    if (idx .eq. echo) idx = 1
	    call sndfput2(fnout, dleft, dright)
	enddo
201	continue
	goto 999

C----	monophonic echo
200	continue
	idx = 1
	do
	    foo = sndfget(fnin, sleft)
	    if (foo .ne. 1) goto 202
	    dleft = ((3 * sleft) + tbleft(idx)) / 4
	    tbleft(idx) = sleft
	    idx = idx + 1
	    if (idx .eq. echo) idx = 1
	    call sndfput(fnout, dleft)
	enddo
202	continue

999	continue

	call sndfclose(fnin)
	call sndfclose(fnout)

	end
C--------------------------------------------------------
