C--------------------------------------------------------
C	s77truc - my second sound effect...
C	http://tontonth.free.fr/sound77.html
C--------------------------------------------------------
	program s77truc

	integer*2	sleft, sright
	integer*2	dleft, dright
	integer*2	scramble(1000)
	integer		idx, foo, frequence
	integer		nbscramb
	integer		fnin, fnout, smplrate, nbchann
	character*100	infname, outfname

C----	prototypes
	integer		sndfopen,sndfget2,sndfget

	if (IARGC() .ne. 2) then
	    print *,'Erreur arguments: infile outfile'
	    call exit(1)
	end if

C----	get and decode parameters
	call getarg(1, infname)
	call getarg(2, outfname)

C----	open input file
	fnin = sndfopen(infname, 'I', smplrate, nbchann)
	if (fnin .lt. 0) then
	    write(6, 50) fnin
	    call exit(2)
	end if
50	format('Err open infile', i5)

C----	create output wavfile
	fnout = sndfopen(outfname, 'O', smplrate, nbchann)
	if (fnout .lt. 0) then
	    write(6, 51) fnout
	    call exit(2)
	end if
51	format('Err open outfile', i5)

	write(6,52) smplrate, nbchann
52	format('s77truc: ', 2i10)

C----	compute the frequency of the scrambler
	frequence = smplrate / 7
	nbscramb = smplrate / 10

	write(6, 53) frequence, nbscramb
53	format('s77truc: frequ ', i6)

C----   build the scrambling table
	do 20 foo=1, nbscramb
	   idx = foo - 1
	   
20	continue




	STOP 'DEBUG'

	if (nbchann .eq. 1) goto 200

C----	stereophonic trucage
	idx = 1
	do
	    foo = sndfget2(fnin, sleft, sright)
	    if (foo .ne. 2) goto 201
	    dleft = sleft
	    dright = sright
	    call sndfput2(fnout, dleft, dright)
	enddo
201	continue
	goto 999

C----	monophonic trucage
200	continue
	idx = 1
	do
	    foo = sndfget(fnin, sleft)
	    if (foo .ne. 1) goto 202
	    dleft = sleft
	    call sndfput(fnout, dleft)
	enddo
202	continue

999	continue

	call sndfclose(fnin)
	call sndfclose(fnout)

	end
C--------------------------------------------------------
