C--------------------------------------------------------
C	convert a .WAV file to ascii integer
C	http://tontonth.free.fr/sound77.html
C--------------------------------------------------------
	program wav77int

C	variables
	integer		foo,fichier
	character*80	fname
	integer		nbrchann

C----	prototypes
	integer		sndfopen

	if (IARGC() .ne. 1) CALL EXIT(1)

	call GETARG(1, fname)
	foo = -1
	fichier = sndfopen(fname, 'I', foo, nbrchann)
	if (fichier .lt. 0) then
	    CALL EXIT(2)
	endif

	if (nbrchann .eq. 1) then
	    call exportmono(fichier)
	elseif (nbrchann .eq. 2) then
	    call exportstereo(fichier)
	endif

	end
C--------------------------------------------------------
	subroutine exportmono(fd)
	integer		fd

	integer		foo,sndfget
	integer*2	samplel

10	continue
	    foo = sndfget(fd, samplel)
	    if (foo .ne. 1) goto 20
	    write(6, 101) samplel
	goto 10
20	continue
101	format(I10)

	end
C--------------------------------------------------------
	subroutine exportstereo(fd)
	integer		fd

	integer		foo,sndfget2
	integer*2	samplel,sampler

10	continue
	    foo = sndfget2(fd, samplel, sampler)
	    if (foo .ne. 2) goto 20
	    write(6, 102) samplel, sampler
	goto 10
20	continue

102	format(2I10)
	end
C--------------------------------------------------------

