C------------------------------------------------------------------------
C	notes.f - unknow location, may be Fonsegrives ?
C------------------------------------------------------------------------
	double precision function freqcoef(freq, sr)
	double precision	freq
	integer			sr

	double precision	dfoo

C	write(6, 10) freq, sr
	dfoo = (freq * 3.141592654d0 * 2.0d0) / dble(sr)
C	write(6, 11) dfoo

10	format('coef:   F:', f8.2, ' SR: ', f8.2)
11	format('        K: ', f12.5)

	freqcoef = dfoo
	end
C------------------------------------------------------------------------
C
C	What are the parameters ?
C	~~~~~~~~~~~~~~~~~~~~~~~~~
C	buff:	an array of integer*2 who hold the samples.
C	nbs:	size of the buffer.
C	freq:	base frequency of the sound.
C	level:	maximum level of the sound [-32760..32760]
C	sr:	sample rate, eg: 44100
C

	subroutine  note01(buff, nbs, freq, level, sr)
	integer			nbs
	integer*2		buff(nbs)
	double precision	freq
	integer			level
	integer			sr

	double precision	k, freqcoef
	integer			step
	integer*2		sample

	k = freqcoef(freq, sr)

	do 10 step=1, nbs

	    sample = 0
	    buff(step) = sample
10	continue

	end
C------------------------------------------------------------------------
C	duration of silence is the number of samples, and samplerate
C	dependant.

	subroutine silence1(fn, nbr)
	integer	fn,nbr
	integer*2	valeur
	integer		i
	valeur = 0
	do 10 i = 1,nbr
	    call sndfput(fn, valeur)
10	continue
	end

	subroutine silence2(fn, nbr)
	integer	fn,nbr
	integer*2	valeur
	integer		i
	valeur = 0
	do 10 i = 1,nbr
	    call sndfput2(fn, valeur, valeur)
10	continue
	end
C------------------------------------------------------------------------

