ccccc------------------------------------------------
	subroutine zweep(nbs, amp, note, rate, fdout)
	integer nbs, amp, note, rate, fdout

	integer			step
	integer*2		sample
	double precision 	freq
	double precision	di,phi,ve
	double precision	dt,val

	double precision	midi2hz

	freq = midi2hz(note)
	write(6,100) note, freq

	do 10, step=1, nbs

ccccc----- calcul enveloppe
	    di = dble(step) / dble(nbs)
	    phi = di * 3.141592654 * 2
	    ve = (1.0 - cos(phi)) / 2.0

ccccc----- calcul du sinus
	    dt = (dble(step) * freq * 1000.0) / dble(rate)
	    val = sin(dt)

	    sample = int(val*32000.0*ve)

C XXX	    write(6, 101) step, ve, val, dt, sample
	    call sndfput(fdout, sample)

10	continue

100	format(i5, ' -> ', f10.4)
101	format(i10, 3('  ', f11.5), '  : ', i7)
	end
c----------------------------------------------------
